package binarytree.core;

import java.util.ArrayList;

public class BinarySearchTree<E extends Comparable<E>> {

	private BinaryTree<E> tree;

	public BinarySearchTree() {
		tree = new BinaryTree<E>();
	}

	// Don't call this on an empty tree
	public BinarySearchTree<E> getLeft() {
		BinarySearchTree<E> newTree = new BinarySearchTree<E>();
		newTree.tree = tree.getLeft();
		return newTree;
	}

	public BinarySearchTree<E> getRight() {
		BinarySearchTree<E> newTree = new BinarySearchTree<E>();
		newTree.tree = tree.getRight();
		return newTree;
	}

	public BinaryTree<E> getTree() {
		return tree;
	}

	public boolean isEmpty() {
		return tree.isEmpty();
	}

	public int size() {
		return tree.size();
	}

	public ArrayList<E> inorder() {
		return tree.inorder();
	}

	public ArrayList<E> preorder() {
		return tree.preorder();
	}

	public ArrayList<E> postorder() {
		return tree.postorder();
	}

	public ArrayList<ArrayList<E>> levelorder() {
		return tree.levelorder();
	}

	public int height() {
		return tree.height();
	}

	@Override
	public String toString() {
		return tree.toString();
	}

	public void insert(E data) {
		if (isEmpty()) {
			tree.setData(data);
		} else {
			if (data.compareTo(tree.getData()) < 0) { // less
				getLeft().insert(data);
			} else { // greater or equal
				getRight().insert(data);
			}
		}
	}

	//////////////////////////////////////////////

	/**
	 * Look up a value in a BST and return a reference to the subtree containing
	 * that value at its root.
	 * 
	 * @param data
	 *            The data to look for
	 * @return The subtree containing data as its root, or null if there is no such
	 *         data.
	 */
	public BinaryTree<E> findSubtree(E data) {
		// TODO Implement me
		return null;
	}

	public E find(E data) {
		// TODO Implement me
		return null;
	}

	public boolean contains(E data) {
		// TODO Implement me
		return false;
	}

	public E remove(E data) {
		// TODO Implement me
		return null;
	}
}
